<template>
  <input
    v-model="inputValue"
    @input="
      [
        updateValue($event.target.value),
        isValid($event.target.value),
        getErrors(validateError),
      ]
    "
    class="form-input"
  />
</template>
<script>
export default {
  data() {
    return {
      inputValue: "",
    };
  },
  props: {
    type: String,
    updateValue: Function,
    getErrors: Function,
    validateError: String,
  },
  methods: {
    isValid(event) {
      if (this.type == "number") {
        if (isNaN(this.inputValue)) {
          this.validateError = "Please Enter Valid Number";
        } else {
          this.validateError = "";
        }
      } else if (this.type == "text") {
        var letters = /^[A-Za-z]+$/;
        if (this.inputValue.match(letters) || this.inputValue.length < 1) {
          this.validateError = "";
        } else {
          this.validateError = "Please Enter Valid Text";
        }
      }
    },
  },
};
</script>
